--- old/usr/src/uts/common/fs/zfs/arc.c	2015-09-11 10:32:14.098326003 +0200
+++ new/usr/src/uts/common/fs/zfs/arc.c	2015-09-11 10:32:14.102390051 +0200
@@ -1301,6 +1301,13 @@
 		VERIFY(!HDR_L2_WRITING(hdr));
 		VERIFY3P(hdr->b_l1hdr.b_tmp_cdata, ==, NULL);
 
+#ifdef ZFS_DEBUG
+		if (hdr->b_l1hdr.b_thawed != NULL) {
+			kmem_free(hdr->b_l1hdr.b_thawed, 1);
+			hdr->b_l1hdr.b_thawed = NULL;
+		}
+#endif
+
 		nhdr->b_flags &= ~ARC_FLAG_HAS_L1HDR;
 	}
 	/*
